<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/Comments/Grouper.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/Comments/Grouper.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/Comments/Grouper.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> QualifiedName</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processors.Transformer <span class="py-keyword">import</span> Transformer</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">import</span> re</span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html">Grouper</a>(Transformer):</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that detects grouping tags and moves the enclosed nodes</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-string">    into a subnode (a 'Group')&quot;&quot;&quot;</span></span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    tags = <span class="py-string">r'^\s*((?P&lt;open&gt;@group\s*(?P&lt;name&gt;.*){)|(?P&lt;close&gt;\s*}))\s*\Z'</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">        Transformer.__init__(self, **kwds)</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">        self.__group_stack = [[]]</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">        self.tags = re.compile(Grouper.tags, re.M)</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#strip_dangling_groups">strip_dangling_groups</a>(self):</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        <span class="py-string">&quot;&quot;&quot;As groups must not overlap with 'real' scopes,</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-string">        make sure all groups created in the current scope are closed</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="py-string">        when leaving the scope.&quot;&quot;&quot;</span></span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        <span class="py-keyword">if</span> self.__group_stack[-1]:</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">'Warning: group stack is non-empty !'</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">            <span class="py-keyword">while</span> (self.__group_stack[-1]):</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">                group = self.__group_stack[-1][-1]</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'forcing closing of group %s (opened near %s:%d)'</span>%(group.name, group.file.name, group.line)</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">                self.pop_group()</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#finalize">finalize</a>(self):</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-string">&quot;&quot;&quot;replace the ASG with the newly created one&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        self.strip_dangling_groups()</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        super(Grouper, self).finalize()</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#push">push</a>(self):</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">        <span class="py-string">&quot;&quot;&quot;starts a new group stack to be able to validate group scopes&quot;&quot;&quot;</span></span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        Transformer.push(self)</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        self.__group_stack.append([])</span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#pop">pop</a>(self, decl):</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Make sure the current group stack is empty.&quot;&quot;&quot;</span></span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        self.strip_dangling_groups()</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        self.__group_stack.pop()</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        Transformer.pop(self, decl)</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#push_group">push_group</a>(self, group):</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Push new group scope to the stack.&quot;&quot;&quot;</span></span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        self.__group_stack[-1].append(group)</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        Transformer.push(self)</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#pop_group">pop_group</a>(self, decl=None):</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Pop a group scope from the stack.</span></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line"><span class="py-string"/></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="py-string">        decl -- an optional declaration from which to extract the context,</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="py-string">        used for the error message if needed.</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        <span class="py-keyword">if</span> self.__group_stack[-1]:</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">            group = self.__group_stack[-1].pop()</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">            group.declarations = self.current_scope()</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            Transformer.pop(self, group)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            <span class="py-keyword">if</span> decl:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: no group open in current scope (near %s:%d), ignoring.&quot;</span>%(decl.file.name, decl.line)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: no group open in current scope, ignoring.&quot;</span></span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#process_comments">process_comments</a>(self, decl):</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Checks for grouping tags.</span></span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line"><span class="py-string">        If an opening tag is found in the middle of a comment, a new Group is generated, the preceeding</span></span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line"><span class="py-string">        comments are associated with it, and is pushed onto the scope stack as well as the groups stack.</span></span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        comments = []</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-keyword">for</span> c <span class="py-keyword">in</span> decl.annotations.get(<span class="py-string">'comments'</span>, []):</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">            <span class="py-keyword">if</span> c <span class="py-keyword">is</span> None:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">                comments.append(None)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">                <span class="py-keyword">continue</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            tag = self.tags.search(c)</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> tag:</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">                comments.append(c)</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                <span class="py-keyword">continue</span></span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">            <span class="py-keyword">elif</span> tag.group(<span class="py-string">'open'</span>):</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">                <span class="py-keyword">if</span> self.debug:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">                    <span class="py-keyword">print</span> <span class="py-string">'found group open tag in'</span>, decl.name</span>
<a id="line99"></a><span class="lineno"> 99</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">                <span class="py-comment"># Open the group. &lt;name&gt; is remainder of line.</span></span>
<a id="line101"></a><span class="lineno">101</span><span class="line">                label = tag.group(<span class="py-string">'name'</span>) <span class="py-keyword">or</span> <span class="py-string">'unnamed'</span></span>
<a id="line102"></a><span class="lineno">102</span><span class="line">                label = label.strip()</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">                <span class="py-comment"># The comment before the open marker becomes the group comment.</span></span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                <span class="py-keyword">if</span> tag.start(<span class="py-string">'open'</span>) &gt; 0:</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">                    c = c[:tag.start(<span class="py-string">'open'</span>)]</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">                    comments.append(c)</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">                group = ASG.Group(decl.file, decl.line, <span class="py-string">'group'</span>, QualifiedName((label,)))</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">                group.annotations[<span class="py-string">'comments'</span>] = comments</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                comments = []</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                self.push_group(group)</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">            <span class="py-keyword">elif</span> tag.group(<span class="py-string">'close'</span>):</span>
<a id="line113"></a><span class="lineno">113</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                <span class="py-keyword">if</span> self.debug:</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">                    <span class="py-keyword">print</span> <span class="py-string">'found group close tag in'</span>, decl.name</span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">                self.pop_group(decl)</span>
<a id="line118"></a><span class="lineno">118</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        decl.annotations[<span class="py-string">'comments'</span>] = comments</span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line123"></a><span class="lineno">123</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        self.process_comments(decl)</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        self.add(decl)</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#visit_scope">visit_scope</a>(self, scope):</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Visits all children of the scope in a new scope. The value of</span></span>
<a id="line129"></a><span class="lineno">129</span><span class="line"><span class="py-string">        current_scope() at the end of the list is used to replace scope's list of</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="py-string">        declarations - hence you can remove (or insert) declarations from the</span></span>
<a id="line131"></a><span class="lineno">131</span><span class="line"><span class="py-string">        list.&quot;&quot;&quot;</span></span>
<a id="line132"></a><span class="lineno">132</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        self.process_comments(scope)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        self.push()</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> scope.declarations: d.accept(self)</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        scope.declarations = self.current_scope()</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        self.pop(scope)</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#visit_enum">visit_enum</a>(self, enum):</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Does the same as visit_scope, but for the enum's list of</span></span>
<a id="line141"></a><span class="lineno">141</span><span class="line"><span class="py-string">        enumerators&quot;&quot;&quot;</span></span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">        self.process_comments(enum)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">        self.push()</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">        <span class="py-keyword">for</span> enumor <span class="py-keyword">in</span> enum.enumerators:</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">            enumor.accept(self)</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        enum.enumerators = self.current_scope()</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        self.pop(enum)</span>
<a id="line149"></a><span class="lineno">149</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Grouper/Grouper.html#visit_enumerator">visit_enumerator</a>(self, enumor):</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Removes dummy enumerators&quot;&quot;&quot;</span></span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">        <span class="py-keyword">if</span> enumor.type == <span class="py-string">&quot;dummy&quot;</span>: <span class="py-keyword">return</span> <span class="py-comment">#This wont work since Core.ASG.Enumerator forces type to &quot;enumerator&quot;</span></span>
<a id="line154"></a><span class="lineno">154</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> len(enumor.name): <span class="py-keyword">return</span> <span class="py-comment"># workaround.</span></span>
<a id="line155"></a><span class="lineno">155</span><span class="line">        self.add(enumor)</span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
